Loading...
Searching...
No Matches
pcl::LeastMedianSquares< PointT > Class Template Reference
Module sample_consensus

LeastMedianSquares represents an implementation of the LMedS (Least Median of Squares) algorithm. More...

`#include <pcl/sample_consensus/lmeds.h>`

Inheritance diagram for pcl::LeastMedianSquares< PointT >:

## Public Types

using | Ptr = shared_ptr<LeastMedianSquares<PointT> >
using | ConstPtr = shared_ptr<const LeastMedianSquares<PointT> >
Public Types inherited from pcl::SampleConsensus< PointT >
using | Ptr
using | ConstPtr

## Public Member Functions

| LeastMedianSquares (const SampleConsensusModelPtr &model)
| LMedS (Least Median of Squares) main constructor.
| LeastMedianSquares (const SampleConsensusModelPtr &model, double threshold)
| LMedS (Least Median of Squares) main constructor.
bool | computeModel (int debug_verbosity_level=0) override
| Compute the actual model and find the inliers.
Public Member Functions inherited from pcl::SampleConsensus< PointT >
void | setSampleConsensusModel (const SampleConsensusModelPtr &model)
| Set the Sample Consensus model to use.
SampleConsensusModelPtr | getSampleConsensusModel () const
| Get the Sample Consensus model used.
virtual | ~SampleConsensus ()=default
| Destructor for base SAC.
void | setDistanceThreshold (double threshold)
| Set the distance to model threshold.
double | getDistanceThreshold () const
| Get the distance to model threshold, as set by the user.
void | setMaxIterations (int max_iterations)
| Set the maximum number of iterations.
int | getMaxIterations () const
| Get the maximum number of iterations, as set by the user.
void | setProbability (double probability)
| Set the desired probability of choosing at least one sample free from outliers.
double | getProbability () const
| Obtain the probability of choosing at least one sample free from outliers, as set by the user.
void | setNumberOfThreads (const int nr_threads=-1)
| Set the number of threads to use or turn off parallelization.
int | getNumberOfThreads () const
| Get the number of threads, as set by the user.
virtual bool | refineModel (const double sigma=3.0, const unsigned int max_iterations=1000)
| Refine the model found.
void | getRandomSamples (const IndicesPtr &indices, std::size_t nr_samples, std::set< index_t > &indices_subset)
| Get a set of randomly selected indices.
void | getModel (Indices &model) const
| Return the best model found so far.
void | getInliers (Indices &inliers) const
| Return the best set of inliers found so far for this model.
void | getModelCoefficients (Eigen::VectorXf &model_coefficients) const
| Return the model coefficients of the best model found so far.

## Additional Inherited Members

Protected Member Functions inherited from pcl::SampleConsensus< PointT >
double | rnd ()
| Boost-based random number generator.
Protected Attributes inherited from pcl::SampleConsensus< PointT >
SampleConsensusModelPtr | sac_model_
| The underlying data model used (i.e.
Indices | model_
| The model found after the last computeModel () as point cloud indices.
Indices | inliers_
| The indices of the points that were chosen as inliers after the last computeModel () call.
Eigen::VectorXf | model_coefficients_
| The coefficients of our model computed directly from the model found.
double | probability_
| Desired probability of choosing at least one sample free from outliers.
int | iterations_
| Total number of internal loop iterations that we've done so far.
double | threshold_
| Distance to model threshold.
int | max_iterations_
| Maximum number of iterations before giving up.
int | threads_
| The number of threads the scheduler should use, or a negative number if no parallelization is wanted.
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm.
std::shared_ptr< boost::uniform_01< boost::mt19937 > > | rng_
| Boost-based random number generator distribution.

## Detailed Description

template<typename PointT>
class pcl::LeastMedianSquares< PointT >

LeastMedianSquares represents an implementation of the LMedS (Least Median of Squares) algorithm.

LMedS is a RANSAC-like model-fitting algorithm that can tolerate up to 50% outliers without requiring thresholds to be set. See Andrea Fusiello's "Elements of Geometric Computer Vision" (http://homepages.inf.ed.ac.uk/rbf/CVonline/LOCAL_COPIES/FUSIELLO4/tutorial.html#x1-520007) for more details. In contrast to RANSAC, LMedS does not divide the points into inliers and outliers when finding the model. Instead, it uses the median of all point-model distances as the measure of how good a model is. A threshold is only needed at the end, when it is determined which points belong to the found model.

Author
  Radu B. Rusu

Definition at line 59 of file lmeds.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::LeastMedianSquares< PointT >::ConstPtr = shared_ptr<const LeastMedianSquares<PointT> >

Definition at line 65 of file lmeds.h.

## Ptr

template<typename PointT>

using pcl::LeastMedianSquares< PointT >::Ptr = shared_ptr<LeastMedianSquares<PointT> >

Definition at line 64 of file lmeds.h.

## Constructor & Destructor Documentation

## LeastMedianSquares() [1/2]

template<typename PointT>

pcl::LeastMedianSquares< PointT >::LeastMedianSquares | ( | const SampleConsensusModelPtr & | model | ) |

inline

LMedS (Least Median of Squares) main constructor.

Parameters

  [in] | model | a Sample Consensus model

Definition at line 78 of file lmeds.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

## LeastMedianSquares() [2/2]

template<typename PointT>

pcl::LeastMedianSquares< PointT >::LeastMedianSquares | ( | const SampleConsensusModelPtr & | model,
|  | double | threshold )

inline

LMedS (Least Median of Squares) main constructor.

Parameters

  [in] | model | a Sample Consensus model
  [in] | threshold | distance to model threshold

Definition at line 89 of file lmeds.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

## Member Function Documentation

## computeModel()

template<typename PointT>

bool pcl::LeastMedianSquares< PointT >::computeModel | ( | int | debug_verbosity_level = 0 | ) |

override virtual

Compute the actual model and find the inliers.

Parameters

  [in] | debug_verbosity_level | enable/disable on-screen debug information and set the verbosity level

Implements pcl::SampleConsensus< PointT >.

Definition at line 49 of file lmeds.hpp.

References pcl::computeMedian(), pcl::SampleConsensus< PointT >::inliers_, pcl::SampleConsensus< PointT >::iterations_, pcl::SampleConsensus< PointT >::max_iterations_, pcl::SampleConsensus< PointT >::model_, pcl::SampleConsensus< PointT >::model_coefficients_, pcl::SampleConsensus< PointT >::sac_model_, and pcl::SampleConsensus< PointT >::threshold_.

The documentation for this class was generated from the following files:

- pcl/sample_consensus/lmeds.h
- pcl/sample_consensus/impl/lmeds.hpp